VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 1  'vbDataSource
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AccessDataCls"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"ReadData"
Private Conn As New ADODB.Connection
Private Rs As New ADODB.Recordset
Private Rs2 As New ADODB.Recordset
Private RecordsetOpen As Boolean
Private RecordsetOpen2 As Boolean
Private TransOpen As Boolean
Private ConcatString As String
Private ConnectString As String
Private ErrorControlOn As Boolean
'local variable(s) to hold property value(s)
Private mvarConnectStr As String 'local copy
Private mvarErrorControlIsOn As Boolean 'local copy
Private mvarShowDeleteMesage As Boolean 'local copy
Private mvarConnectionType As ConnectType 'local copy
Public Enum ConnectType
    OnDemand = 0
    Persist = 1
End Enum

Public Property Let ConnectionType(ByVal vData As ConnectType)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ConnectionType = 5
    mvarConnectionType = vData
End Property


Public Property Get ConnectionType() As ConnectType
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ConnectionType
    ConnectionType = mvarConnectionType
End Property




Public Property Let ShowDeleteMesage(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ShowDeleteMesage = 5
    mvarShowDeleteMesage = vData
End Property


Public Property Get ShowDeleteMesage() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ShowDeleteMesage
    ShowDeleteMesage = mvarShowDeleteMesage
End Property




Public Property Let ErrorControlIsOn(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ErrorControlOn = 5
    mvarErrorControlIsOn = vData
    ErrorControlOn = ErrorControlIsOn
End Property
Public Property Get ErrorControlIsOn() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ErrorControlOn
    ErrorControlIsOn = mvarErrorControlIsOn
End Property
Public Property Let ConnectStr(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ConnectStr = 5
    mvarConnectStr = vData
    ConnectString = mvarConnectStr
End Property
Public Property Get ConnectStr() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ConnectStr
    ConnectStr = mvarConnectStr
End Property
Public Function DeleteRecords(ByVal SqlStr As String) As Boolean
    Dim RsCount As Integer
    'PURPOSE: To delete records from database
    If ErrorControlOn Then On Error GoTo Error_Control_Error
    If Not Conn.State = adStateOpen Then
        ConnectDb
    End If
    Conn.Execute SqlStr, RsCount
    MsgBox RsCount & " Records Were Deleted"
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    DeleteRecords = True
    Exit Function
Error_Control_Exit:
    Exit Function
Error_Control_Error:
    DisplayError
    If ConcatString <> "" Then
        MsgBox ConcatString
    End If
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    DeleteRecords = False
    Resume Error_Control_Exit:
End Function

Public Function GetData(ByVal SqlStr As String) As Recordset
    'PURPOSE: To return a recordset based on SQL string Provided
    If ErrorControlOn Then On Error GoTo Error_Control_Error
    If Not Conn.State = adStateOpen Then
        ConnectDb
    End If
    Rs.Open SqlStr, Conn, , adLockReadOnly
    RecordsetOpen = True
    Set GetData = Rs
    If ConnectionType = OnDemand Then
        Set Conn = Nothing
    End If
    Set Rs = Nothing
    RecordsetOpen = False
    'DisConnectDb
    Exit Function
Error_Control_Exit:
    Exit Function
Error_Control_Error:
    DisplayError
    If ConcatString <> "" Then
        MsgBox ConcatString
    End If
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    Resume Error_Control_Exit:

End Function

Public Function AddData(ByVal SqlStr As String, RecordArray() As Variant) As Boolean

    'PURPOSE: To add a new record
    Dim a As Integer
    Dim Size1 As Integer
    Dim RsCount As Integer
    
    If ErrorControlOn Then On Error GoTo Error_Control_Error
    
    'Check array size
    Size1 = UBound(RecordArray)
    
    'Connect to database
    If Not Conn.State = adStateOpen Then
        ConnectDb
    End If
    Conn.BeginTrans
    TransOpen = True
    Rs2.Open SqlStr, Conn, adOpenKeyset, adLockOptimistic
    RecordsetOpen = True
    Rs2.AddNew
    For a = 0 To Size1
        If Not RecordArray(a) = Empty Then
            Rs2.Fields(a).Value = RecordArray(a)
        End If
    Next
    Rs2.Update
    AddData = True
    Rs2.Close
    RecordsetOpen = False
    Conn.CommitTrans
    TransOpen = False
    Set Rs2 = Nothing
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    Exit Function
Error_Control_Exit:
    Exit Function
Error_Control_Error:
   If TransOpen = True Then
        Conn.RollbackTrans
        DisplayError
        If ConcatString <> "" Then
            MsgBox ConcatString
        End If
    End If
    AddData = False
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    Resume Error_Control_Exit:
End Function

Public Function EditData(ByVal SqlStr As String, RecordArray() As Variant) As Boolean
    'PURPOSE: To edit existing records
    Dim a As Integer
    Dim Size1 As Integer
    Dim RsCount As Integer
    
    If ErrorControlOn Then On Error GoTo Error_Control_Error
    
    'Check array size
    Size1 = UBound(RecordArray)
    
    'Connect to database
    If Not Conn.State = adStateOpen Then
        ConnectDb
    End If
    Conn.BeginTrans
    TransOpen = True
    Rs2.Open SqlStr, Conn, adOpenKeyset, adLockOptimistic
    RecordsetOpen = True
    If Not Rs2.EOF Then
        'Loop all records
        a = 0
        RsCount = Rs2.RecordCount
        If RsCount > 1 Then
            MsgBox "More Than One Record Found Edit Failed"
            EditData = False
        Else
            For a = 0 To Size1
                If Not RecordArray(a) = Empty Then
                    Rs2.Fields(a).Value = RecordArray(a)
                End If
            Next
            Rs2.Update
            EditData = True
        End If
        Rs2.Close
        RecordsetOpen = False
        Conn.CommitTrans
        TransOpen = False
        Set Rs2 = Nothing
    Else
        Conn.RollbackTrans
        Rs2.Close
        RecordsetOpen = False
        Set Rs2 = Nothing
        MsgBox "Record Not Found Edit Failed"
        EditData = False
    End If
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    Exit Function
Error_Control_Exit:
    Exit Function
Error_Control_Error:
   If TransOpen = True Then
        Conn.RollbackTrans
        DisplayError
        If ConcatString <> "" Then
            MsgBox ConcatString
        End If
    End If
    EditData = False
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    Resume Error_Control_Exit:
End Function

Private Sub ConnectDb()
    'PURPOSE: To make the ADO connection to the Database
    If ErrorControlOn Then On Error GoTo Error_Control_Error
    Conn.ConnectionTimeout = 0
    Conn.CommandTimeout = 0
    Conn.CursorLocation = adUseClient
    Conn.Open ConnectString
    Exit Sub
Error_Control_Exit:
    Exit Sub
Error_Control_Error:
    DisplayError
    If ConcatString <> "" Then
        MsgBox ConcatString
    End If
    Resume Error_Control_Exit:
End Sub

Private Sub DisConnectDb()
    'PURPOSE: To close the recordset and connection to the database
    If ErrorControlOn Then On Error GoTo Error_Control_Error
    If RecordsetOpen = True Then
        Set Rs = Nothing
        RecordsetOpen = False
    End If
    If RecordsetOpen2 = True Then
        Set Rs2 = Nothing
        RecordsetOpen2 = False
    End If
    Conn.Close
    Set Conn = Nothing
    Exit Sub
Error_Control_Exit:
    Exit Sub
Error_Control_Error:
    Resume Error_Control_Exit:
End Sub

Private Sub DisplayError()
    ConcatString = ""
    Dim ec As Integer
    
    If Conn.Errors.Count > 0 Then
        For ec = 0 To Conn.Errors.Count - 1
            ConcatString = ConcatString & "DB Error Number: " & Conn.Errors(ec).Number & vbNewLine
            ConcatString = ConcatString & "     Source: " & Conn.Errors(ec).Source & vbNewLine
            ConcatString = ConcatString & "             " & Conn.Errors(ec).Description & vbNewLine
            ConcatString = ConcatString & vbNewLine
        Next
    
        If TransOpen = True Then
            ConcatString = ConcatString & "ADO.RollBack" & vbNewLine
            ConcatString = ConcatString & "          Saving of data was rolled back due to error occuring.  Nothing was saved."
            ConcatString = ConcatString & vbNewLine
            RollBackOccured = False
        End If
    Else
        ConcatString = ConcatString & "In Code Error Number: " & Err.Number & vbNewLine
        ConcatString = ConcatString & "          " & Err.Description & vbNewLine
        ConcatString = ConcatString & vbNewLine
    
    End If
End Sub

Public Function CheckData(ByVal TableName As String, ByVal FieldName As String, ByVal Value As Variant) As Boolean
    If ErrorControlOn Then On Error GoTo Error_Control_Error
    
    If Not Conn.State = adStateOpen Then
        ConnectDb
    End If
    Rs.Open TableName, Conn, , , adCmdTable
    If Not Rs.EOF Then
        Rs.MoveFirst
        Rs.Find FieldName & "=" & Value
        If Not Rs.EOF Then
            CheckData = True
        Else
            CheckData = False
        End If
    Else
        CheckData = False
    End If
    Set Rs = Nothing
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    Exit Function
Error_Control_Exit:
    Exit Function
Error_Control_Error:
    DisplayError
    If ConcatString <> "" Then
        MsgBox ConcatString
    End If
    CheckData = False
    If ConnectionType = OnDemand Then
        DisConnectDb
    End If
    Resume Error_Control_Exit:
End Function

Private Sub Class_Terminate()
    DisConnectDb
End Sub
