VERSION 5.00
Begin VB.Form frm1 
   ClientHeight    =   5730
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7125
   LinkTopic       =   "Form1"
   ScaleHeight     =   5730
   ScaleWidth      =   7125
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox ClientCodeEntry 
      Height          =   315
      Left            =   0
      MaxLength       =   10
      TabIndex        =   0
      Top             =   240
      Width           =   1500
   End
   Begin VB.TextBox LNameEntry 
      Height          =   315
      Left            =   3720
      MaxLength       =   50
      TabIndex        =   2
      Top             =   240
      Width           =   2100
   End
   Begin VB.TextBox FNameEntry 
      Height          =   315
      Left            =   1560
      MaxLength       =   50
      TabIndex        =   1
      Top             =   240
      Width           =   2100
   End
   Begin VB.CommandButton DeleteBtn 
      Caption         =   "Delete"
      Height          =   315
      Left            =   5800
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton AddDataBtn 
      Caption         =   "Add Data"
      Height          =   315
      Left            =   5800
      TabIndex        =   3
      Top             =   240
      Width           =   1215
   End
   Begin VB.CommandButton GetDataBtn 
      Caption         =   "Get Data"
      Height          =   315
      Left            =   5800
      TabIndex        =   4
      Top             =   720
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   3765
      Left            =   0
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   600
      Width           =   5775
   End
   Begin VB.Label Label7 
      Caption         =   "Please email questions or bugs to : support@sofrwarethatmatters.com"
      Height          =   195
      Left            =   0
      TabIndex        =   13
      Top             =   4680
      Width           =   6855
   End
   Begin VB.Label Label4 
      Caption         =   "SBSSDataAccessDll  V1.0.1"
      Height          =   195
      Left            =   0
      TabIndex        =   12
      Top             =   4440
      Width           =   2415
   End
   Begin VB.Label Label5 
      Caption         =   "Please email any ideas for improving this product to : ideas@sofrwarethatmatters.com"
      Height          =   195
      Left            =   0
      TabIndex        =   11
      Top             =   4920
      Width           =   6855
   End
   Begin VB.Label Label6 
      Caption         =   $"Form1.frx":0000
      Height          =   555
      Left            =   0
      TabIndex        =   10
      Top             =   5160
      Width           =   6855
   End
   Begin VB.Label Label3 
      Caption         =   "Client Code"
      Height          =   255
      Left            =   0
      TabIndex        =   9
      Top             =   0
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Last Name"
      Height          =   255
      Left            =   3720
      TabIndex        =   8
      Top             =   0
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "First Name"
      Height          =   255
      Left            =   1560
      TabIndex        =   7
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "frm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public Dbacc As New SBSSDataAccessDll.AccessDataCls
Dim SQLString As String
Dim RecordArray()

Private Sub AddDataBtn_Click()
    Dim DataAdded As Boolean
    
    'ReDim the Array. Database fielda are 0 based
    'so we declare the array as 0 based
    ReDim RecordArray(0 To 3)
    
    'Assign values to the array for saving.
    'Field 0 in database is auto number so
    'we can't set or change the value.
    'If you don't assign a value to an array element
    'that array element is "= Empty" and the field is skipped
    RecordArray(1) = ClientCodeEntry.Text
    RecordArray(2) = FNameEntry.Text
    RecordArray(3) = LNameEntry.Text
    If AddDataBtn.Caption = "Edit Data" Then
    
        'Build the SQL string
        SQLString = "SELECT * From ClientNames "
        SQLString = SQLString & "WHERE ClientCode = '" & ClientCodeEntry.Text & "'"
        
        'Call the EditData method of the Dll
        DataAdded = Dbacc.EditData(SQLString, RecordArray)
        
        ClientCodeEntry.Text = ""
        FNameEntry.Text = ""
        LNameEntry.Text = ""
        AddDataBtn.Caption = "Add Data"
    Else
        If Trim(ClientCodeEntry.Text) = "" Then
            MsgBox "This is a required field"
            ClientCodeEntry.SetFocus
            Exit Sub
        End If
        
        'Check if the Client code is already in the table
        DataAdded = Dbacc.CheckData("ClientNames", "ClientCode", ClientCodeEntry.Text)
        If DataAdded = True Then
            MsgBox "Client Code already exists"
            ClientCodeEntry.SetFocus
        Else
            
            'Build the SQL string
            SQLString = "SELECT * From ClientNames "
            SQLString = SQLString & "WHERE ClientCode = ''"
            
            'Call the AddData method of the Dll
            DataAdded = Dbacc.AddData(SQLString, RecordArray)
            ClientCodeEntry.Text = ""
            FNameEntry.Text = ""
            LNameEntry.Text = ""
        End If
    End If
    Call ClearArray
    GetDataBtn = True
End Sub

Private Sub DeleteBtn_Click()
    Dim DataDeleted As Boolean
    If List1.ListCount > 0 Then
    
        'Build the SQL string
        SQLString = "DELETE * From ClientNames "
        SQLString = SQLString & "WHERE ClientCode = '" & Trim(Left(List1.Text, 10)) & "'"
        
        'Call the DeleteRecords method of the Dll
        DataDeleted = Dbacc.DeleteRecords(SQLString)
        
    End If
    GetDataBtn = True
End Sub

Private Sub Form_Load()
    Dim DBLocation As String
    Dim DbName As String
    Dim ConnectStr As String
    DBLocation = App.Path
    DbName = "\DataAccess.mdb"
    ConnectStr = "Provider=Microsoft.Jet.OLEDB.3.51;" & _
                "Data Source=" & DBLocation & DbName & ";"
    
    'Set ConnectStr property
    Dbacc.ConnectStr = ConnectStr
    
    'Set the connection type
    'OnDemand opens and closes the connection with each use
    'Persist keeps the connection open until the object is set = Nothing
    'Persist will give you greater speed but uses more resources
    Dbacc.ConnectionType = Persist
    
    'Set ErrorControlIsOn property
    Dbacc.ErrorControlIsOn = True
    
    'Sets whether or not the delete message shows on delete
    Dbacc.ShowDeleteMesage = False
End Sub

Private Sub Form_Unload(Cancel As Integer)

    'Destroy object
    Set Dbacc = Nothing
    
End Sub

Private Sub GetDataBtn_Click()
    Dim RS As New Recordset
    
    'Build SQL string
    SQLString = "SELECT * From ClientNames "
    SQLString = SQLString & "ORDER BY ClientPk"
    
    'Call the GetData method of the Dll
    'and assign to recordset
    Set RS = Dbacc.GetData(SQLString)
    List1.Clear
    If RS.State <> 0 Then
    Do Until RS.EOF
        List1.AddItem Left(RS.Fields(1) & "          ", 10) & ", " & RS.Fields(2) & ", " & RS.Fields(3)
        RS.MoveNext
    Loop
    End If
End Sub

Private Sub List1_DblClick()
    Dim Pos As Integer
    Dim TextString As String
    If List1.ListCount > 0 Then
        TextString = List1.Text
        Pos = InStr(1, TextString, ", ")
        ClientCodeEntry.Text = Left(List1.Text, Pos - 1)
        TextString = Mid(List1.Text, Pos + 2)
        Pos = InStr(1, TextString, ", ")
        FNameEntry.Text = Left(TextString, Pos - 1)
        LNameEntry.Text = Mid(TextString, Pos + 2)
        AddDataBtn.Caption = "Edit Data"
    End If
End Sub

Private Sub ClearArray()
    Dim A, Size1 As Integer
    Size1 = UBound(RecordArray)
    For A = 0 To Size1
        'Reset array elements
        RecordArray(A) = Empty
    Next
        
End Sub
